// index.js for ePMPme 
// a Cordova based app to install/diagnose Cambium ePMP SMs
//    
//    Copyright 2017 Joel Newkirk
//    epmpme@newkirk.us
//
//    You may alter this program and its relevant files as you see fit subject to these restrictions:
//    1 - do not sell this software or any derivative thereof
//    2 - maintain this comment block in all files, and note the above copyright, in any redistribution


var dev={ip:localStorage.ip||"169.254.1.1",url:localStorage.url||"http://169.254.1.1",user:localStorage.user||"admin",pass:localStorage.pass||"admin",audible:0,vibe:0,regged:0};
var netmode=['!','N','B','R'];
var w=700;
var h=500;
var pri={0:"Norm",1:"High",2:"Low"};
var geoOpts={ maximumAge: 600000, timeout: 120000, enableHighAccuracy: true };

var app = {
    initialize: function() {
        this.bindEvents();
    },
    bindEvents: function() {
        document.addEventListener('deviceready', this.onDeviceReady, false);
    },
    onDeviceReady: function() {
        app.receivedEvent('deviceready');
    },
    receivedEvent: function(id) {
	$(document).ready(function() {
    $('#busy').position({my:'center',at:'center',of:'#app'});
	    $('#loginbut').button();
	    w=$(window).innerWidth();
	    h=$(window).innerHeight();
	    $('#app').width(w).height(h);
	    $('#busy').show().position({my:'center',at:'center',of:'#app'});
	    $('#busy').hide();
	    $('#tabbage').hammer().bind("pan",panHandler);
    	    $('#loginpane').show().width(w).height(h).position({my:'center',at:'center',of:'#app'});
	    LowLatencyAudio.preloadFX('ring',"sound/Ring.wav",function(msg){},function(msg){});
	    $.extend($.gritter.options, {
		position: 'bottom-right',
		fade_in_speed: 200,
		fade_out_speed: 600,
		time: 1500
	    });
	    $('#tabbage').show().tabs({
		heightStyle:'fill',
		activate: function( event, ui ) {
		    if ($('#tabbage').tabs('option','active')==2)
		    {
			dev['ea_int']=setInterval(function(){getAlign();},500);
			dev['alert_int']=setInterval(function(){alignAlert();},2000);
			if (!dev.st_int)
			{
			    dev['st_int']=setInterval(function(){getStatus();},3000);
			}
			window.plugins.insomnia.keepAwake();
		    }
		    else if ($('#tabbage').tabs('option','active')<2)
		    {
			if (!dev.st_int)
			{
			    dev['st_int']=setInterval(function(){getStatus();},3000);
			}
			if (dev.ea_int)
			{
			    clearInterval(dev.ea_int);
			    delete dev.ea_int;
			    window.plugins.insomnia.allowSleepAgain();
			}
			if (dev.alert_int)
			{
			    clearInterval(dev.alert_int);
			    delete dev.alert_int;
			    dev.audible=0;
			    dev.vibe=0;
			}
		    }
		    else
		    {
			if (dev.st_int)
			{
			    clearInterval(dev.st_int);
			    delete dev.st_int;
			}
			if (dev.ea_int)
			{
			    clearInterval(dev.ea_int);
			    delete dev.ea_int;
			    window.plugins.insomnia.allowSleepAgain();
			}
			if (dev.alert_int)
			{
			    clearInterval(dev.alert_int);
			    delete dev.alert_int;
			    dev.audible=0;
			    dev.vibe=0;
			}
		    }
		}
	    }).hide();
	    fit();
	    $.ajaxSetup({ timeout: 3000, cache:false });
	    $('#ip-n').hide();
	    $('#ip-r').hide();
	    $('#loginform').submit(function( event ) {
		dev.ip=$('#ip').val().toLowerCase();
		if (dev.ip.indexOf("http")===0)
		{
		    dev.url=dev.ip;
		}
		else
		{
		    dev.url="http://"+dev.ip;
		}
		dev.user=$('#username').val();
		dev.pass=$('#password').val();
		if ($('#remember').prop('checked'))
		{
		    window.localStorage.ip=dev.ip;
		    window.localStorage.url=dev.url;
		    window.localStorage.user=dev.user;
		    window.localStorage.pass=dev.pass;
		}
		$('#busy').show();
		$('#busy').position({my:'center',at:'center',of:'#app'}).zIndex(111);
		loadRadio();
		event.preventDefault();
	    });
	    
	    $('#cfg_mode').on('change',function(){
		var sel=$('#cfg_mode option:selected').val();
		if (sel=="route")
		{
		    $('#ip-n,#ip-b').hide();
		    $('#ip-r').show();
		}
		else if (sel=="bridge")
		{
		    $('#ip-n,#ip-r').hide();
		    $('#ip-b').show();
		}
		else
		{
		    $('#ip-r,#ip-b').hide();
		    $('#ip-n').show();
		}
	    });

	    $('#configform').submit(function( event ) {
		saveConfig();
		event.preventDefault();
	    });

	    fit();
	    $('#ip').val(dev.ip);
	    $('#username').val(dev.user);
	    $('#password').val(dev.pass);

	    $('#ea_meter').meter({
		meter:"css/images/dial-back.png",
		glass:"css/images/glass.png",
		minAngle:-90,
		maxAngle:90,
		width:320,
		height:166,
		needlePosition:[162,160],
		level:-90,
		minLevel:-85,
		maxLevel:-55
	    }).position({my:"bottom",at:"bottom"});

	});
	$('#gpsget').click(function(){getGPS();});
	$('#audible').click(function(){
	    if (dev.audible==1)
	    {
		dev.audible=0;
		$('#audible').attr('src','css/images/mute.png');
	    }
	    else
	    {
		dev.audible=1;
		$('#audible').attr('src','css/images/audible.png');
	    }
	});
	window.addEventListener("orientationchange", function() {
	    setTimeout(fit,400);
	}, false);
	window.addEventListener("resize", function() {
	    setTimeout(fit,400);
	}, false);
    
        document.addEventListener("backbutton", function(){
	    if ($('#loginpane').is(':visible'))
	    {
		if($('#busy').is(':visible'))
		{
		    $('#busy').hide(200);
		}
		else
		{
		    window.plugins.insomnia.allowSleepAgain();
	    	    navigator.app.exitApp();
		}
	    }
	    else
	    {
		if (dev.ea_int)
		{
		    clearInterval(dev.ea_int);
		    delete dev.ea_int;
		    window.plugins.insomnia.allowSleepAgain();
		}
		if (dev.alert_int)
		{
		    clearInterval(dev.alert_int);
		    delete dev.alert_int;
		    dev.audible=0;
		    dev.vibe=0;
		}
		if (dev.st_int)
		{
		    clearInterval(dev.st_int);
		    delete dev.st_int;
		}
	        $('#ea_meter').meter('setLevel',-90);
	        $('#dump span').empty();
	        $('.ea_span').empty();
	        $('.st_span').empty();
	        $('#tabbage').hide();
		$('#loginpane').show().width($(window).innerWidth()).height(window.innerHeight).position({my:'center',at:'center',of:'#app'});

            }
	},false);
    }
};

function fit()
{
    w=$(window).innerWidth();
    h=$(window).innerHeight();
    $('#app').width(w).height(h);
    if($('#loginpane').is(':visible'))
    {
	$('#loginpane').width(w).height(h).position({my:'center',at:'center',of:'#app'});
    }
    $('#tabbage').tabs('refresh');
    $('#busy').position({my:'center',at:'center',of:'#app'});
}

function panHandler(ev)
{
    if(ev.gesture.isFinal && (Math.abs(ev.gesture.deltaX)>Math.abs(ev.gesture.deltaY)*1.25))
    {
	var act=$('#tabbage').tabs("option","active");
	if (ev.gesture.deltaX<0)
	{
	    if (act<3)
	    {
		act++;
	    }
	    $('#tabbage').tabs("option","active",act);
	}
	else
	{
	    if (act>0)
	    {
		act--;
	    }
	    $('#tabbage').tabs("option","active",act);
	}
    }
}


function loadRadio()
{
//alert("loadRadio()");
    $.ajax({
	url: dev.url+"/index.html",
	timeout: 3000,
	cache:false,
	dataType:'html',
	context: document.body
    }).success(function(front) {
	ver=$(front).find("#sw_version").html();
//alert("Version "+ver);
	stage1(ver);
    }).error(function(data,error) {
	alert(dev.url+"/index.html failed\n"+JSON.stringify(data)+"\n:::"+error);
	$('#busy').hide(200);
    });
}

function stage1(ver)
{
//alert("stage1");
    $.ajax({
	url: dev.url+"/cgi-bin/luci",
	timeout: 3000,
	data:{username:"dashboard",password:""},
	cache:false,
	dataType:'json',
	context: document.body
    }).success(function(data) {
	stage2(data.stok,ver);
    }).error(function(data,error) {
	alert(dev.ip+" failed\n"+JSON.stringify(data)+"\n:::"+error);
	$('#busy').hide(200);
    });
}

function stage2(stok,ver)
{
//alert(ver);
    var urlfrag="/admin/get_param_prior";
    if (ver.search("2.")>-1)
    {
	urlfrag="/admin/get_param";
    }
    if (ver=="3.1")
    {
	urlfrag="/admin/get_param";
    }
    if (ver.search("3.0")>-1)
    {
	urlfrag="/admin/get_param";
    }
    $.ajax({
	url: dev.url+"/cgi-bin/luci/;stok="+stok+urlfrag,
	data:{act:"prior",debug:0},
	dataType:'json',
	method:"POST",
	context: document.body
    }).success(function(data) {
	if (data["success"]==1)
	{
	    dev["name"]=data.device_props.cambiumEffectiveDeviceName;
	    stage3(stok);
	}
	else
	{
	    alert("Something broke!\n"+JSON.stringify(data));
	}
    }).error(function(data,error) {
	$.gritter.add({title:dev.ip+' failed',text:JSON.stringify(data)+"\n"+error,time:10000});
	$('#busy').hide(200);
    });
}

function stage3(stok)
{
    $.ajax({
	url: dev.url+"/cgi-bin/luci",
	data:{username:dev.user,password:dev.pass,prevsess:stok},
	dataType:'json',
	method:"POST",
	context: document.body
    }).success(function(data) {
	dev['stok']=data.stok;
	$('#loginpane').hide();
	$('#busy').hide(300);
	$('#tabbage').show().tabs('refresh');
	dev.regged=0;
	dev.audible=0;
	$('#audible').attr('src','css/images/mute.png');
	dev.vibe=0;
	getStatus();
	getAlign();
	getConfig();
	fit();
	$('#tabbage').tabs('option','active',0);
	fit();
    }).error(function(data,error) {
	$.gritter.add({title:dev.ip+' login failed',text:JSON.stringify(data)+"\n"+error,time:10000});
	$('#busy').hide(200);
    });
}

function getGPS()
{
    $.gritter.add({title:'getting GPS coordinates',text:''},5000);
    navigator.geolocation.getCurrentPosition(GPSfix, onGPSError,geoOpts);    
}

function GPSfix(position)
{
    $('#cfg_lat').val(position.coords.latitude);
    $('#cfg_lon').val(position.coords.longitude);
}

function onGPSError(error)
{
    if (error.code==2 && (error.message=="GPS provider disabled." || error.message=="GPS provider is not available."))
    {
        $.gritter.add({title:"GPS failure",text:error.message});
    }
    else
    {
        $.gritter.add({title:"GPS error",text:'code: '+error.code+'\n'+'message: '+error.message+'\n'});
    }
}


function getConfig()
{
    $.ajax({
	url: dev.url+"/cgi-bin/luci/;stok="+dev.stok+"/admin/get_param",
	timeout: 5000,
	data:{"act":"config_regular","debug":"0"},
	dataType:'json',
	method:"POST",
	context: document.body
    }).success(function(data) {
	dev['config']=data.device_props;
	$('#configdump').html("<pre>CONFIG:"+JSON.stringify(data.device_props,null,4)+"</pre>");
	$('#ip-n,#ip-r,#ip-b').hide();
	$('#st_mir').html(dev.config.wirelessMIRSTAProfileNumber);
	$('#st_loc').html(dev.config.snmpSystemDescription);
	$('#cfg_name').val(dev.config.systemConfigDeviceName);
	$('#cfg_desc').val(dev.config.snmpSystemDescription);
	$('#cfg_lat').val(dev.config.cambiumDeviceLatitude);
	$('#cfg_lon').val(dev.config.cambiumDeviceLongitude);
	$('#cfg_hgt').val(dev.config.systemDeviceLocHeight);
	$('#cfg_mir').val(dev.config.wirelessMIRSTAProfileNumber);
	$('#cfg_pri').val(dev.config.wirelessSTAPriority);
	if(dev.config.networkMode==2) // bridging
	{
	    $('#ip-b').show();
	    $('#cfg_b_ip').val(dev.config.networkBridgeIPAddr);
	    $('#cfg_b_subnet').val(dev.config.networkBridgeNetmask);
	    $('#cfg_b_gw').val(dev.config.networkBridgeGatewayIP);
	}
	if (dev.config.networkMode==1) //NAT
	{
	    $('#ip-n').show();
	    if (dev.config.networkWanIPAddressMode==1) // static
	    {
		$('#ip-np').show();
		$('#cfg_np_ip').val(dev.config.networkWanIPAddr);
		$('#cfg_np_subnet').val(dev.config.networkWanNetmask);
		$('#cfg_np_gw').val(dev.config.networkWanGatewayIP);
	    }
	    if (dev.config.mgmtIFEnable==1 && dev.config.mgmtIFIPAddressMode==1) // mgmt IP enabled and set to static
	    {
		$('#ip-nm').show();
		$('#cfg_nm_ip').val(dev.config.cambiumManagementIFIPAddress);
		$('#cfg_nm_subnet').val(dev.config.cambiumManagementIFNetMask);
		$('#cfg_nm_gw').val(dev.config.cambiumManagementIFGateway);
	    }
	    if (dev.config.networkLanIPAddressMode==1)
	    {
		$('#ip-nl').show();
		$('#cfg_nl_ip').val(dev.config.networkLanIPAddr);
		$('#cfg_nl_subnet').val(dev.config.networkLanNetmask);
	    }
	}
	if (dev.config.networkMode==3) // routing
	{
	    $('#ip-r').show();
	    if (dev.config.networkWanIPAddressMode==1) // static
	    {
		$('#ip-rp').show();
		$('#cfg_rp_ip').val(dev.config.networkWanIPAddr);
		$('#cfg_rp_subnet').val(dev.config.networkWanNetmask);
		$('#cfg_rp_gw').val(dev.config.networkWanGatewayIP);
	    }
	    if (dev.config.mgmtIFEnable==1 && dev.config.mgmtIFIPAddressMode==1) // mgmt IP enabled and set to static
	    {
		$('#ip-rm').show();
		$('#cfg_rm_ip').val(dev.config.cambiumManagementIFIPAddress);
		$('#cfg_rm_subnet').val(dev.config.cambiumManagementIFNetMask);
		$('#cfg_rm_gw').val(dev.config.cambiumManagementIFGateway);
	    }
	    if (dev.config.networkLanIPAddressMode==1)
	    {
		$('#ip-rl').show();
		$('#cfg_rl_ip').val(dev.config.networkLanIPAddr);
		$('#cfg_rl_subnet').val(dev.config.networkLanNetmask);
	    }
	}
	dev['config_id']=data.template_props.config_id;
    }).error(function(data,error) {
	alert(dev.ip+' getConfig failed\n'+JSON.stringify(data));
	$('#busy').hide();
    });
}

function saveConfig()
{
    
    var confdata={
	    "device_props":{
	    "wirelessMIRSTAProfileNumber":$('#cfg_mir').val(),
	    "snmpSystemDescription":$('#cfg_desc').val(),
	    "snmpSystemName":$('#cfg_name').val(),
	    "systemConfigDeviceName":$('#cfg_name').val(),
	    "systemDeviceLocLatitude":$('#cfg_lat').val(),
	    "systemDeviceLocLongitude":$('#cfg_lon').val(),
	    "systemDeviceLocHeight":$('#cfg_hgt').val(),
	    "wirelessSTAPriority":$('#cfg_pri').val()
	    },
	    "template_props":{
		"config_id":dev.config_id
	    }
    };
    if (dev.config.networkMode==2) // NAT - ignore static vs DHCP toggle, if DHCP then saving IPs won't break anything.
    {
	    confdata.device_props.networkWanGatewayIP=$('#cfg_np_gw').val();
	    confdata.device_props.networkWanIPAddr=$('#cfg_np_ip').val();
	    confdata.device_props.networkWanNetmask=$('#cfg_np_subnet').val();
	    confdata.device_props.networkLanIPAddr=$('#cfg_nl_ip').val();
	    confdata.device_props.networkLanNetmask=$('#cfg_nl_subnet').val();
	    confdata.device_props.mgmtIFGateway=$('#cfg_nm_gw').val();
	    confdata.device_props.mgmtIFIPAddr=$('#cfg_nm_ip').val();
	    confdata.device_props.mgmtIFNetmask=$('#cfg_nm_subnet').val();
    }
    else if (dev.config.networkMode==3) // Router
    {
	    confdata.device_props.networkWanGatewayIP=$('#cfg_rp_gw').val();
	    confdata.device_props.networkWanIPAddr=$('#cfg_rp_ip').val();
	    confdata.device_props.networkWanNetmask=$('#cfg_rp_subnet').val();
	    confdata.device_props.networkLanIPAddr=$('#cfg_rl_ip').val();
	    confdata.device_props.networkLanNetmask=$('#cfg_rl_subnet').val();
	    confdata.device_props.mgmtIFGateway=$('#cfg_rm_gw').val();
	    confdata.device_props.mgmtIFIPAddr=$('#cfg_rm_ip').val();
	    confdata.device_props.mgmtIFNetmask=$('#cfg_rm_subnet').val();
    }
    else // Bridge
    {
	    confdata.device_props.networkBridgeGatewayIP=$('#cfg_gw').val();
	    confdata.device_props.networkBridgeIPAddr=$('#cfg_ip').val();
	    confdata.device_props.networkBridgeNetmask=$('#cfg_subnet').val();
    }

    $.ajax({
	url: dev.url+"/cgi-bin/luci/;stok="+dev.stok+"/admin/set_param",
	timeout: 5000,
	data:{"changed_elements":JSON.stringify(confdata),"debug":0},
	dataType:'json',
	method:"POST",
	context: document.body
    }).success(function(data) {
	$.gritter.add({
    	    title:dev.ip+"Saved Settings, applying changes",
    	    text:"",
    	    time:5000
	});
	$.ajax({
	    url: dev.url+"/cgi-bin/luci/;stok="+dev.stok+"/admin/apply_param",
	    timeout: 5000,
	    data:{"debug":0}
	}).success(function(data){
	    $.gritter.add({
    		title:dev.ip+"Applied Settings changes, reboot required",
    		text:"",
    		time:5000
	    });
	    getStatus();
	    getConfig();
	});
    }).error(function(data,error) {
	$.gritter.add({
    	    title:dev.ip+"Save Settings failed",
    	    text:JSON.stringify(data)+"\n"+error,
    	    time:10000
	});
    });
}
function resetFields()
{	
    $('#ea_meter').meter('setLevel',-90);
    $('#statusdump,#configdump').empty();
    $('#st_name,#st_ip,#st_swv,#st_mac,#st_freq,#st_dist,#st_dbm').empty();
    $('#st_snr,#st_mcs,#st_apname,#st_apmac,#st_pri,#st_ssid,#ea_freq').empty();
    $('#ea_dist,#ea_dbm,#ea_snr,#ea_mcs,#ea_apname,#ea_apmac,#ea_ssid').empty();
    $('#ea_bignum,#ea_ch0rssi,#ea_ch1rssi').empty();
}


function getStatus()
{
    $.ajax({
	url: dev.url+"/cgi-bin/luci/;stok="+dev.stok+"/admin/get_param",
	data:{"act":"status","measure":"s","debug":"0"},
	method:"POST",
	dataType:'json',
	context: document.body
    }).success(function(data) {
	dev['status']=data.device_props;
//	$('#statusdump').html("<pre>STATUS:"+JSON.stringify(data.device_props,null,4)+"</pre>");
	dev.regged=data.device_props.sysNetworkEntrySuccess;
//	$('#apdump').html("<pre>"+JSON.stringify(data.device_props.cambiumSTAConnectedAPTable,null,4)+"</pre>");
	var aps=data.device_props.cambiumSTAConnectedAPTable;
	$('#apdiv').empty();
	aps.forEach(function(ap){
	    var entry="<div class='apdiv";
	    if (ap.connectedAPNEState===0)
	    {
		entry+=" current'>";
	    }
	    else if (ap.connectedAPMeetNEAttemptCriteria=="No" || ap.connectedAPRemainingSTA<1)
	    {
	    	entry+=" nogood'>";
	    }
	    else if (ap.connectedAPRemainingSTA<10 || ap.connectedAPSNR<15)
	    {
		entry+=" limited'>";
	    }
	    else
	    {
		entry+=" good'>";
	    }
	    entry+="<div>SSID "+ap.connectedAPSSID+"</div><div>Freq "+ap.connectedAPFrequency+"</div>";
	    entry+="<div>RSSI "+ap.connectedAPRSSI+"</div><div>SNR "+ap.connectedAPSNR+"</div>";
	    entry+="</div>";
	    $('#apdiv').append(entry);
	});
	$('#st_name').html(dev.status.cambiumEffectiveDeviceName);
	$('#st_gps').html("<a class='gpslink' href='geo:0,0?q="+dev.status.cambiumDeviceLatitude+","+dev.status.cambiumDeviceLongitude+"'>("+dev.status.cambiumDeviceLatitude+","+dev.status.cambiumDeviceLongitude+")</a>");
	$('#st_ip').html(dev.status.cambiumEffectiveDeviceIPAddress+" - "+netmode[dev.status.cambiumEffectiveSTANetworkMode]);
	$('#st_swv').html(dev.status.cambiumCurrentSWInfo);
	$('#st_mac').html(dev.status.cambiumLANMACAddress);
	$('#st_freq,#ea_freq').html(dev.status.cambiumSTAConnectedRFFrequency);
	$('#st_dist,#ea_dist').html(dev.status.cambiumSTADistanceMil+"mi");
	$('#st_dbm,#ea_dbm').html(dev.status.cambiumSTADLRSSI+"dB");
	$('#st_snr,#ea_snr').html(dev.status.cambiumSTADLSNR+"dB");
	$('#st_mcs,#ea_mcs').html(dev.status.cambiumSTADownlinkMCSMode+"/"+dev.status.cambiumSTAUplinkMCSMode);
	$('#st_apname,#ea_apname').html(dev.status.cambiumSTAConnectedAP);
	$('#st_apmac,#ea_apmac').html(dev.status.cambiumConnectedAPMACAddress);
	$('#st_pri').html(pri[dev.status.cambiumSTAPriority]);
	$('#st_ssid,#ea_ssid').html(dev.status.cambiumEffectiveSSID);

//	$('#st_').html(dev.status.);
    }).error(function(data,error) {
	$.gritter.add({
            title:dev.ip+"getStatus failed",
            text:JSON.stringify(data)+"\n"+error
        });
    });
}


function getAlign()
{
    $.ajax({
	url: dev.url+"/cgi-bin/luci/;stok="+dev.stok+"/admin/get_ealign",
	timeout: 1500,
	data:{"debug":"0"},
	method:"POST",
	dataType:'json',
	context: document.body
    }).success(function(data) {
	$('#ea_bignum').html(data.eAlignRSSIcombine+"dBm");
	$('#statusdump').html("<pre>CONFIG:"+JSON.stringify(data,null,4)+"</pre>");
	$('#ea_ch0rssi').html("Ch0: "+data.eAlignRSSIch0+"dB");
	$('#ea_ch1rssi').html("Ch1: "+data.eAlignRSSIch1+"dB");
	$('#ea_meter').meter('setLevel',data.eAlignRSSIcombine).position({my:"bottom",at:"bottom"});
	dev.status.eAlignRSSIcombine=data.eAlignRSSIcombine;
    }).error(function(data,error) {
	$.gritter.add({
            title:dev.ip+"getAlign failed",
            text:JSON.stringify(data)
        });
    });
}

function playit()
{
    LowLatencyAudio.play('ring',function(msg){},function(msg){});
}

function alignAlert()
{

    if (dev.regged)
    {
	if (dev.audible)
	{
	    if (dev.status.eAlignRSSIcombine>-55)
	    {
		playit();
		setTimeout(function() {
		    if (dev.regged && dev.audible)
		    {
			playit();
		    }
		}, 500);
		setTimeout(function() {
		    if (dev.regged && dev.audible)
		    {
			playit();
		    }
		}, 1000);
		setTimeout(function() {
		    if (dev.regged && dev.audible)
		    {
			playit();
		    }
		}, 1500);
	    }
	    else if (dev.status.eAlignRSSIcombine>-65)
	    {
		playit();
		setTimeout(function() {
		    if (dev.regged && dev.audible)
		    {
			playit();
		    }
		}, 666);
		setTimeout(function() {
		    if (dev.regged && dev.audible)
		    {
			playit();
		    }
		}, 1332);
	    }
	    else if (dev.status.eAlignRSSIcombine>-75)
	    {
		playit();
		setTimeout(function() {
		    if (dev.regged && dev.audible)
		    {
			playit();
		    }
		}, 1000);
	    }
	    else
	    {
		playit();
	    }
	}
	else // not audible
	{
//
	}
	if (dev.vibe)
	{
	    if (dev.status.eAlignRSSIcombine>-50) {navigator.vibrate([450, 50,450,50]);}
	    else if (dev.status.eAlignRSSIcombine>-57) {navigator.vibrate([350, 150,350,150]);}
	    else if (dev.status.eAlignRSSIcombine>-65) {navigator.vibrate([250, 250,250,250]);}
	    else if (dev.status.eAlignRSSIcombine>-72) {navigator.vibrate([150, 350,150,350]);}
	    else {navigator.vibrate([50, 450,50,450]);}
	}
    }
    else // not regged
    {
//
    }
}
